## simde 0.0.0.git.20200421

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(simde-tests)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
include (ExtraWarningFlags)

enable_testing()

option(BUILD_CPP_TESTS "Build C++ tests" ON)
option(ALWAYS_BUILD_NATIVE_TESTS "Build 'native' tests even if the native instructions aren't available" OFF)

if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/munit/munit.c")
  find_program(GIT git)
  if(GIT)
    execute_process(COMMAND ${GIT} submodule update --init --recursive)
  else()
    message (FATAL_ERROR "It looks like you don't have submodules checked out.  Please run `git submodule update --init --recursive'")
  endif()
endif()

if(CMAKE_BUILD_TYPE STREQUAL "")
  set(CMAKE_BUILD_TYPE "Debug")
elseif(CMAKE_BUILD_TYPE STREQUAL "Coverage")
  set(orig_req_libs "${CMAKE_REQUIRED_LIBRARIES}")
  set(CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES};--coverage")
  check_c_compiler_flag("--coverage" CFLAG___coverage)
  set(CMAKE_REQUIRED_LIBRARIES "${orig_req_libs}")

  if(CFLAG___coverage)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_C_FLAGS} --coverage")
    add_definitions("-DSIMDE_NO_INLINE")
  else()
    set(CMAKE_BUILD_TYPE "Debug")
  endif()
endif()

add_library(munit STATIC munit/munit.c)

include(CheckFunctionExists)
check_function_exists(clock_gettime CLOCK_GETTIME_RES)
if(CLOCK_GETTIME_RES)
  set(CLOCK_GETTIME_EXISTS yes)
else()
  set(orig_req_libs "${CMAKE_REQUIRED_LIBRARIES}")
  set(CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES};rt")

  check_function_exists(clock_gettime CLOCK_GETTIME_LIBRT_RES)
  if(CLOCK_GETTIME_LIBRT_RES)
    set(CLOCK_GETTIME_EXISTS yes)
    set(CLOCK_GETTIME_LIBRARY "rt")
  endif()

  set(CMAKE_REQUIRED_LIBRARIES "${orig_req_libs}")
  unset(orig_req_libs)
endif()

check_function_exists(fegetround FEGETROUND_EXISTS)
if(NOT FEGETROUND_EXISTS)
  unset(FEGETROUND_EXISTS CACHE)
  list(APPEND CMAKE_REQUIRED_LIBRARIES m)
  check_function_exists(fegetround FEGETROUND_EXISTS)
  if(FEGETROUND_EXISTS)
    set(NEED_LIBM True)
  else()
    message(FATAL_ERROR "Unable to find fegetround")
  endif()
endif(NOT FEGETROUND_EXISTS)

set_property(TARGET munit PROPERTY C_STANDARD "99")
if("${CLOCK_GETTIME_EXISTS}")
  target_compile_definitions(munit PRIVATE "MUNIT_ALLOW_CLOCK_GETTIME")
  target_link_libraries(munit "${CLOCK_GETTIME_LIBRARY}")
endif()

if("${OPENMP_SIMD_FLAGS}" STREQUAL "")
  foreach(omp_simd_flag "-fopenmp-simd" "-qopenmp-simd")
    string (REGEX REPLACE "[^a-zA-Z0-9]+" "_" omp_simd_flag_name "CFLAG_${omp_simd_flag}")
    check_c_compiler_flag("${omp_simd_flag}" "${omp_simd_flag_name}")

    if(${omp_simd_flag_name})
      set(OPENMP_SIMD_FLAGS "-DSIMDE_ENABLE_OPENMP ${omp_simd_flag}")
      break()
    endif()
  endforeach()
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OPENMP_SIMD_FLAGS}")

set(TEST_SOURCES_C
  x86/mmx.c
  x86/sse.c
  x86/sse2.c
  x86/sse3.c
  x86/ssse3.c
  x86/sse4.1.c
  x86/sse4.2.c
  x86/avx.c
  x86/avx2.c
  x86/avx512f.c
  x86/avx512bw.c
  x86/avx512vl.c
  x86/fma.c
  x86/svml.c

  arm/neon/vadd.c
  arm/neon/vdup_n.c
  arm/neon/vmul.c
  arm/neon/vsub.c)

set(TEST_RUNNER_SOURCES
  run-tests.c
  x86/test-x86.c
  arm/neon/test-neon.c
  arm/test-arm.c)
add_executable(run-tests ${TEST_RUNNER_SOURCES})
set_property(TARGET run-tests PROPERTY C_STANDARD "99")
target_link_libraries(run-tests munit)
target_add_compiler_flags (munit "-w")
if(NEED_LIBM)
  target_link_libraries(run-tests m)
endif(NEED_LIBM)

set(TEST_SOURCES_CPP)
if(BUILD_CPP_TESTS)
  foreach(csource ${TEST_SOURCES_C})
    configure_file("${csource}" "${CMAKE_CURRENT_BINARY_DIR}/${csource}pp")
    list(APPEND TEST_SOURCES_CPP "${CMAKE_CURRENT_BINARY_DIR}/${csource}pp")
  endforeach()

  add_definitions(-DSIMDE_BUILD_CPP_TESTS)
endif(BUILD_CPP_TESTS)

foreach(native native emul)
  add_library(simde-test-${native} STATIC ${TEST_SOURCES_C} ${TEST_SOURCES_CPP})

  target_include_directories(simde-test-${native} PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/..")
  set_property(TARGET simde-test-${native} PROPERTY C_STANDARD "99")

  if(ALWAYS_BUILD_NATIVE_TESTS)
    target_compile_definitions(simde-test-${native} PRIVATE SIMDE_ALWAYS_BUILD_NATIVE_TESTS)
  endif(ALWAYS_BUILD_NATIVE_TESTS)

  target_link_libraries(run-tests simde-test-${native})
endforeach(native native emul)
target_compile_definitions(simde-test-emul PRIVATE SIMDE_NO_NATIVE)

foreach(tst
      "/x86/mmx"
      "/x86/sse"
      "/x86/sse2"
      "/x86/sse3"
      "/x86/ssse3"
      "/x86/sse4.1"
      "/x86/sse4.2"
      "/x86/avx"
      "/x86/fma"
      "/x86/avx2"
      "/x86/avx512f"
      "/x86/avx512bw"
      "/x86/avx512vl"
      "/x86/svml"
    )
  add_test(NAME "${tst}/${variant}" COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:run-tests> "${tst}")
endforeach()

=== debian/changelog ===
simde (0.0.0.git.20200421-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 21 Apr 2020 18:26:12 +0200

simde (0.0.0.git.20200419-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sun, 19 Apr 2020 21:34:54 +0200

simde (0.0.0.git.20200415-1) unstable; urgency=medium

  * Disable clang on ppc64
  * Release as arch: all
  * New upstream version

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 16 Apr 2020 16:15:35 +0200

simde (0.0.0.git.20200414-1) unstable; urgency=medium

  * Fix clang skip logic
  * New upstream version

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 14 Apr 2020 11:51:26 +0200

simde (0.0.0.git.20200412-1) unstable; urgency=medium

  * New upstream version
  * Parallelize building in the autopkgtests
  * debian/{control,rules}: skip clang where it is not available
  * debian/rules: armel: add -latomic

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 13 Apr 2020 09:35:08 +0200

simde (0.0.0.git.20200408-1) unstable; urgency=medium

  * Team upload.

  [ Michael R. Crusoe ]
  * New upstream version

  [ Andreas Tille ]
  * Test-Depends: build-essential

 -- Andreas Tille <tille@debian.org>  Mon, 13 Apr 2020 07:33:38 +0200

simde (0.0.0.git.20200402-1) unstable; urgency=medium

  * Initial release. (Closes: #946299)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 02 Apr 2020 09:53:54 +0200

## simde 0.0.0.git.20200424

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -38,15 +38,15 @@
 
 add_library(munit STATIC munit/munit.c)
 
-include(CheckFunctionExists)
-check_function_exists(clock_gettime CLOCK_GETTIME_RES)
+include(CheckSymbolExists)
+check_symbol_exists(clock_gettime "time.h" CLOCK_GETTIME_RES)
 if(CLOCK_GETTIME_RES)
   set(CLOCK_GETTIME_EXISTS yes)
 else()
   set(orig_req_libs "${CMAKE_REQUIRED_LIBRARIES}")
   set(CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES};rt")
 
-  check_function_exists(clock_gettime CLOCK_GETTIME_LIBRT_RES)
+  check_symbol_exists(clock_gettime "time.h" CLOCK_GETTIME_LIBRT_RES)
   if(CLOCK_GETTIME_LIBRT_RES)
     set(CLOCK_GETTIME_EXISTS yes)
     set(CLOCK_GETTIME_LIBRARY "rt")
@@ -56,11 +56,11 @@
   unset(orig_req_libs)
 endif()
 
-check_function_exists(fegetround FEGETROUND_EXISTS)
+check_symbol_exists(fegetround "fenv.h" FEGETROUND_EXISTS)
 if(NOT FEGETROUND_EXISTS)
   unset(FEGETROUND_EXISTS CACHE)
   list(APPEND CMAKE_REQUIRED_LIBRARIES m)
-  check_function_exists(fegetround FEGETROUND_EXISTS)
+  check_symbol_exists(fegetround "fenv.h" FEGETROUND_EXISTS)
   if(FEGETROUND_EXISTS)
     set(NEED_LIBM True)
   else()

=== debian/changelog ===
simde (0.0.0.git.20200424-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 24 Apr 2020 18:50:02 +0200

=== debian/control ===
Source: simde
Section: libdevel
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               clang [!alpha !hppa !ia64 !m68k !ppc64 !sh4 !x32] <!nocheck>
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/simde
Vcs-Git: https://salsa.debian.org/med-team/simde.git
Homepage: https://github.com/nemequ/simde
Rules-Requires-Root: no

Package: libsimde-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Implementations of SIMD instructions for all systems
 SIMDe provides fast, portable implementations of SIMD intrinsics on hardware
 which doesn't natively support them, such as calling SSE functions on ARM.
 There is no performance penalty if the hardware supports the native
 implementation (e.g., SSE/AVX runs at full speed on x86, NEON on ARM, etc.).
 .
 This makes porting code to other architectures much easier in a few key ways:
 .
 First, instead of forcing you to rewrite everything for each architecture,
 SIMDe lets you get a port up and running almost effortlessly. You can then
 start working on switching the most performance-critical sections to native
 intrinsics, improving performance gradually. SIMDe lets (for example) SSE/AVX
 and NEON code exist side-by-side, in the same implementation.
 .
 Second, SIMDe makes it easier to write code targeting ISA extensions you don't
 have convenient access to. You can run NEON code on your x86 machine without an
 emulator. Obviously you'll eventually want to test on the actual hardware
 you're targeting, but for most development, SIMDe can provide a much easier
 path.
 .
 SIMDe takes a very different approach from most other SIMD abstraction layers
 in that it aims to expose the entire functionality of the underlying
 instruction set. Instead of limiting functionality to the lowest common
 denominator, SIMDe tries to minimize the amount of effort required to port
 while still allowing you the space to optimize as needed.
 .
 The current focus is on writing complete portable implementations, though a
 large number of functions already have accelerated implementations using one
 (or more) of the following:
 .
     SIMD intrinsics from other ISA extensions (e.g., using NEON to implement
 SSE).
     Compiler-specific vector extensions and built-ins such as
 __builtin_shufflevector and __builtin_convertvector
     Compiler auto-vectorization hints, using:
        OpenMP 4 SIMD
        Cilk Plus
        GCC loop-specific pragmas
        clang pragma loop hint directives

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

CLANG_SKIP=alpha hppa ia64 m68k ppc64 sh4 x32
# ppc64 is due to https://github.com/nemequ/simde/issues/185

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

ifneq (,$(filter $(DEB_BUILD_ARCH),armel))
  export DEB_LDFLAGS_MAINT_APPEND=-latomic
endif

%:
	dh $@ --sourcedirectory=test --builddirectory=gcc_test

override_dh_auto_configure:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	CC=gcc CXX=g++ dh_auto_configure --builddirectory=gcc_test --sourcedirectory=test
  ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
	CC=clang CXX=clang++ dh_auto_configure --builddirectory=clang_test --sourcedirectory=test
  endif
endif

override_dh_auto_build:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_build --builddirectory=gcc_test --sourcedirectory=test
  ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
	dh_auto_build --builddirectory=clang_test --sourcedirectory=test
  endif
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --builddirectory=gcc_test --sourcedirectory=test
  ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
	dh_auto_test --builddirectory=clang_test --sourcedirectory=test
  endif
endif

override_dh_auto_clean:
	dh_auto_clean --builddirectory=gcc_test --sourcedirectory=test
ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
	dh_auto_clean --builddirectory=clang_test --sourcedirectory=test
endif

=== debian/watch ===
# alternatively to this template you might like to try
#   https://github.com/FedericoCeratto/debian-package-init/blob/master/deb_create_watch.py

version=4

# Uncomment to find new files on Github
#  - when using releases:
# https://github.com/#GITHUBUSER#/#PACKAGE#/releases/latest .*/archive/#PREFIX#@ANY_VERSION@@ARCHIVE_EXT@
#  - when using tags
# https://github.com/#GITHUBUSER#/#PACKAGE#/tags .*/#PREFIX#@ANY_VERSION@@ARCHIVE_EXT@
# Remark: frequently you can do s/#PREFIX#/v?/ since 'v' or nothing is quite common but there are other prefixes possible

# Any Git repository lacking versioned downloads
#
# Option 1: mode=git
# ------------------
#
#opts="mode=git,pretty=0.0+git%cd.%h" \
#    https://github.com/#user#/#project#.git HEAD
#
# Option 2: github_commits_package_json (only for Github)
# -------------------------------------------------------
#
# opts="uversionmangle=s/.*date=(\d{4})-(\d\d)-(\d\d)T.*/#VERSION_ma_be_0.0#+git$1$2$3/, \
#    filenamemangle=s/.*date=(\d{4})-(\d\d)-(\d\d)T.*/#VERSION_ma_be_0.0#+git$1$2$3.tar.gz/, \
#    repack,compression=xz" \
#    https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=github_commits_package_json/#user#/#project# \
#    .*/archive/(.*\.tar\.gz?.*)

opts="uversionmangle=s/.*date=(\d{4})-(\d\d)-(\d\d)T.*/0.0.0.git.$1$2$3/, \
   filenamemangle=s/.*date=(\d{4})-(\d\d)-(\d\d)T.*/0.0.0.git.$1$2$3.tar.gz/, \
   repack,compression=xz" \
   https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=github_commits_package_json/nemequ/simde \
   .*/archive/(.*\.tar\.gz?.*)

## simde 0.0.0.git.20200522

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -101,6 +101,9 @@
   x86/avx512f.c
   x86/avx512bw.c
   x86/avx512vl.c
+  x86/avx512dq.c
+  x86/avx512cd.c
+  x86/gfni.c
   x86/fma.c
   x86/svml.c
 
@@ -143,6 +146,7 @@
   endif(ALWAYS_BUILD_NATIVE_TESTS)
 
   target_link_libraries(run-tests simde-test-${native})
+  target_add_compiler_flags(simde-test-${native} "-Wno-psabi")
 endforeach(native native emul)
 target_compile_definitions(simde-test-emul PRIVATE SIMDE_NO_NATIVE)
 
@@ -160,6 +164,8 @@
       "/x86/avx512f"
       "/x86/avx512bw"
       "/x86/avx512vl"
+      "/x86/avx512dq"
+      "/x86/gfni"
       "/x86/svml"
     )
   add_test(NAME "${tst}/${variant}" COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:run-tests> "${tst}")

=== debian/changelog ===
simde (0.0.0.git.20200522-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 22 May 2020 21:54:08 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
 Build-Depends: debhelper-compat (= 12),
                cmake,
-               clang [!alpha !hppa !ia64 !m68k !ppc64 !sh4 !x32] <!nocheck>
+               clang [!alpha !hppa !ia64 !m68k !sh4 !x32] <!nocheck>
 Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/simde
 Vcs-Git: https://salsa.debian.org/med-team/simde.git

## simde 0.0.0.git.20200531

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,6 @@
 enable_testing()
 
 option(BUILD_CPP_TESTS "Build C++ tests" ON)
-option(ALWAYS_BUILD_NATIVE_TESTS "Build 'native' tests even if the native instructions aren't available" OFF)
 
 if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/munit/munit.c")
   find_program(GIT git)
@@ -141,10 +140,6 @@
   target_include_directories(simde-test-${native} PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/..")
   set_property(TARGET simde-test-${native} PROPERTY C_STANDARD "99")
 
-  if(ALWAYS_BUILD_NATIVE_TESTS)
-    target_compile_definitions(simde-test-${native} PRIVATE SIMDE_ALWAYS_BUILD_NATIVE_TESTS)
-  endif(ALWAYS_BUILD_NATIVE_TESTS)
-
   target_link_libraries(run-tests simde-test-${native})
   target_add_compiler_flags(simde-test-${native} "-Wno-psabi")
 endforeach(native native emul)

=== debian/changelog ===
simde (0.0.0.git.20200531-1) unstable; urgency=medium

  * New upstream version. Closes: #961599.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 01 Jun 2020 19:49:33 +0200

simde (0.0.0.git.20200526-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 26 May 2020 10:43:34 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: libdevel
 Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
+Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Build-Depends: debhelper-compat (= 12),
                cmake,
                clang [!alpha !hppa !ia64 !m68k !sh4 !x32] <!nocheck>

## simde 0.0.0.git.20200611

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -106,16 +106,24 @@
   x86/fma.c
   x86/svml.c
 
-  arm/neon/vadd.c
-  arm/neon/vdup_n.c
-  arm/neon/vmul.c
-  arm/neon/vsub.c)
+  arm/neon/add.c
+  arm/neon/and.c
+  arm/neon/dup_n.c
+  arm/neon/eor.c
+  arm/neon/get_high.c
+  arm/neon/get_low.c
+  arm/neon/min.c
+  arm/neon/mla.c
+  arm/neon/mul.c
+  arm/neon/orr.c
+  arm/neon/pmin.c
+  arm/neon/sub.c)
 
 set(TEST_RUNNER_SOURCES
   run-tests.c
-  x86/test-x86.c
-  arm/neon/test-neon.c
-  arm/test-arm.c)
+  x86/run-tests.c
+  arm/run-tests.c
+  arm/neon/run-tests.c)
 add_executable(run-tests ${TEST_RUNNER_SOURCES})
 set_property(TARGET run-tests PROPERTY C_STANDARD "99")
 target_link_libraries(run-tests munit)
@@ -151,8 +159,8 @@
       "/x86/sse2"
       "/x86/sse3"
       "/x86/ssse3"
-      "/x86/sse4.1"
-      "/x86/sse4.2"
+      "/x86/sse4_1"
+      "/x86/sse4_2"
       "/x86/avx"
       "/x86/fma"
       "/x86/avx2"
@@ -162,6 +170,7 @@
       "/x86/avx512dq"
       "/x86/gfni"
       "/x86/svml"
+      "/arm"
     )
   add_test(NAME "${tst}/${variant}" COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:run-tests> "${tst}")
 endforeach()

=== debian/changelog ===
simde (0.0.0.git.20200611-1) unstable; urgency=medium

  * New upstream version
  * Refresh munit patch

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 11 Jun 2020 10:29:43 +0200

## simde 0.0.0.git.20200616

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -107,17 +107,25 @@
   x86/svml.c
 
   arm/neon/add.c
+  arm/neon/addw.c
   arm/neon/and.c
   arm/neon/dup_n.c
   arm/neon/eor.c
   arm/neon/get_high.c
+  arm/neon/get_lane.c
   arm/neon/get_low.c
   arm/neon/min.c
   arm/neon/mla.c
   arm/neon/mul.c
+  arm/neon/mull.c
   arm/neon/orr.c
+  arm/neon/padd.c
   arm/neon/pmin.c
-  arm/neon/sub.c)
+  arm/neon/shl_n.c
+  arm/neon/shr_n.c
+  arm/neon/sub.c
+  arm/neon/uzp1.c
+  arm/neon/uzp2.c)
 
 set(TEST_RUNNER_SOURCES
   run-tests.c

=== debian/changelog ===
simde (0.0.0.git.20200616-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 17 Jun 2020 11:18:22 +0200

## simde 0.0.0.git.20200619

=== debian/changelog ===
simde (0.0.0.git.20200619-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 19 Jun 2020 12:31:07 +0200

## simde 0.0.0.git.20200619.2.5fb12ac

=== debian/changelog ===
simde (0.0.0.git.20200619.2.5fb12ac-1) unstable; urgency=medium

  * New upstream version with fix for plink2 on ppc64el

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 20 Jun 2020 09:55:06 +0200

## simde 0.0.0.git.20200620

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -109,6 +109,8 @@
   arm/neon/add.c
   arm/neon/addw.c
   arm/neon/and.c
+  arm/neon/bsl.c
+  arm/neon/cagt.c
   arm/neon/dup_n.c
   arm/neon/eor.c
   arm/neon/get_high.c
@@ -121,6 +123,8 @@
   arm/neon/orr.c
   arm/neon/padd.c
   arm/neon/pmin.c
+  arm/neon/reinterpret.c
+  arm/neon/shl.c
   arm/neon/shl_n.c
   arm/neon/shr_n.c
   arm/neon/sub.c

=== debian/changelog ===
simde (0.0.0.git.20200620-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 20 Jun 2020 15:35:52 +0200

## simde 0.5.0

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -116,12 +116,14 @@
   arm/neon/get_high.c
   arm/neon/get_lane.c
   arm/neon/get_low.c
+  arm/neon/max.c
   arm/neon/min.c
   arm/neon/mla.c
   arm/neon/mul.c
   arm/neon/mull.c
   arm/neon/orr.c
   arm/neon/padd.c
+  arm/neon/pmax.c
   arm/neon/pmin.c
   arm/neon/reinterpret.c
   arm/neon/shl.c
@@ -149,6 +151,9 @@
   foreach(csource ${TEST_SOURCES_C})
     configure_file("${csource}" "${CMAKE_CURRENT_BINARY_DIR}/${csource}pp")
     list(APPEND TEST_SOURCES_CPP "${CMAKE_CURRENT_BINARY_DIR}/${csource}pp")
+
+    get_filename_component(DIR "${csource}" DIRECTORY)
+    set_property(SOURCE "${CMAKE_CURRENT_BINARY_DIR}/${csource}pp" APPEND PROPERTY COMPILE_FLAGS " -I${CMAKE_CURRENT_SOURCE_DIR}/${DIR}")
   endforeach()
 
   add_definitions(-DSIMDE_BUILD_CPP_TESTS)

=== debian/changelog ===
simde (0.5.0-1) unstable; urgency=medium

  * New upstream version
  * debhelper-compat 13 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 23 Jun 2020 13:24:06 +0200

## simde 0.6.0

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -106,32 +106,99 @@
   x86/fma.c
   x86/svml.c
 
+  arm/neon/abd.c
+  arm/neon/abs.c
   arm/neon/add.c
+  arm/neon/addl.c
+  arm/neon/addl_high.c
   arm/neon/addw.c
   arm/neon/and.c
   arm/neon/bsl.c
   arm/neon/cagt.c
+  arm/neon/ceq.c
+  arm/neon/ceqz.c
+  arm/neon/cge.c
+  arm/neon/cgez.c
+  arm/neon/cgt.c
+  arm/neon/cgtz.c
+  arm/neon/cle.c
+  arm/neon/clez.c
+  arm/neon/clt.c
+  arm/neon/cltz.c
+  arm/neon/cvt.c
+  arm/neon/combine.c
+  arm/neon/create.c
+  arm/neon/dot.c
+  arm/neon/dot_lane.c
   arm/neon/dup_n.c
   arm/neon/eor.c
+  arm/neon/ext.c
   arm/neon/get_high.c
   arm/neon/get_lane.c
   arm/neon/get_low.c
   arm/neon/max.c
   arm/neon/min.c
   arm/neon/mla.c
+  arm/neon/mla_n.c
+  arm/neon/mlal.c
+  arm/neon/mlal_high.c
+  arm/neon/movl.c
+  arm/neon/movl_high.c
+  arm/neon/movn.c
   arm/neon/mul.c
+  arm/neon/mul_n.c
   arm/neon/mull.c
+  arm/neon/mull_n.c
+  arm/neon/mvn.c
+  arm/neon/neg.c
   arm/neon/orr.c
+  arm/neon/padal.c
   arm/neon/padd.c
+  arm/neon/paddl.c
   arm/neon/pmax.c
   arm/neon/pmin.c
+  arm/neon/qadd.c
+  arm/neon/qdmulh.c
+  arm/neon/qdmull.c
+  arm/neon/qrdmulh.c
+  arm/neon/qrdmulh_n.c
+  arm/neon/qmovn.c
+  arm/neon/qmovn_high.c
+  arm/neon/qmovun.c
+  arm/neon/qtbl.c
+  arm/neon/qtbx.c
+  arm/neon/rbit.c
   arm/neon/reinterpret.c
+  arm/neon/rev16.c
+  arm/neon/rev32.c
+  arm/neon/rev64.c
+  arm/neon/rhadd.c
+  arm/neon/rshl.c
+  arm/neon/rshr_n.c
+  arm/neon/rsra_n.c
+  arm/neon/set_lane.c
+  arm/neon/st1_lane.c
+  arm/neon/st3.c
+  arm/neon/st4.c
   arm/neon/shl.c
   arm/neon/shl_n.c
   arm/neon/shr_n.c
+  arm/neon/sra_n.c
   arm/neon/sub.c
+  arm/neon/subl.c
+  arm/neon/tbl.c
+  arm/neon/tbx.c
+  arm/neon/trn.c
+  arm/neon/trn1.c
+  arm/neon/trn2.c
+  arm/neon/tst.c
+  arm/neon/uzp.c
   arm/neon/uzp1.c
-  arm/neon/uzp2.c)
+  arm/neon/uzp2.c
+  arm/neon/zip.c
+  arm/neon/zip1.c
+  arm/neon/zip2.c
+  )
 
 set(TEST_RUNNER_SOURCES
   run-tests.c
@@ -189,5 +256,5 @@
       "/x86/svml"
       "/arm"
     )
-  add_test(NAME "${tst}/${variant}" COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:run-tests> "${tst}")
+  add_test(NAME "${tst}/${variant}" COMMAND $<TARGET_FILE:run-tests> "${tst}")
 endforeach()

=== debian/changelog ===
simde (0.6.0-3~mx17+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Revert to dh-compat 12.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 05 Oct 2020 18:51:31 -0700

simde (0.6.0-3) unstable; urgency=medium

  * Add patch for better altivec support from upstream.

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 04 Sep 2020 10:39:45 +0200

simde (0.6.0-2) unstable; urgency=medium

  * Add two patches for 32bit x86 from upstream.

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 02 Sep 2020 11:39:33 +0200

simde (0.6.0-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 24 Aug 2020 17:50:12 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: simde
 Section: libdevel
 Priority: optional
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Michael R. Crusoe <crusoe@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: clang [!alpha !hppa !ia64 !m68k !sh4 !x32] <!nocheck>,
                cmake,
-               clang [!alpha !hppa !ia64 !m68k !sh4 !x32] <!nocheck>
+               debhelper-compat (= 12)
 Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/simde
 Vcs-Git: https://salsa.debian.org/med-team/simde.git
-Homepage: https://github.com/nemequ/simde
+Homepage: https://github.com/simd-everywhere/simde
 Rules-Requires-Root: no
 
 Package: libsimde-dev

=== debian/tests/control ===
Tests: run-unit-test
Depends: build-essential, clang, cmake, @
Restrictions: allow-stderr

## simde 0.7.0

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -87,6 +87,20 @@
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OPENMP_SIMD_FLAGS}")
 
+if("${CMAKE_C_COMPILER_ID}" STREQUAL "Intel")
+  add_definitions(-DSIMDE_FAST_MATH)
+endif()
+
+aux_source_directory("arm/neon" ARM_NEON_SOURCES_C)
+list(REMOVE_ITEM ARM_NEON_SOURCES_C "arm/neon/run-tests.c")
+list(REMOVE_ITEM ARM_NEON_SOURCES_C "arm/neon/skel.c")
+list(REMOVE_ITEM ARM_NEON_SOURCES_C "arm/neon/skel-single.c")
+list(REMOVE_ITEM ARM_NEON_SOURCES_C "arm/neon/skel-triple.c")
+
+aux_source_directory("x86/avx512" X86_AVX512_SOURCES_C)
+list(REMOVE_ITEM X86_AVX512_SOURCES_C "x86/avx512/run-tests.c")
+list(REMOVE_ITEM X86_AVX512_SOURCES_C "x86/avx512/skel.c")
+
 set(TEST_SOURCES_C
   x86/mmx.c
   x86/sse.c
@@ -97,116 +111,23 @@
   x86/sse4.2.c
   x86/avx.c
   x86/avx2.c
-  x86/avx512f.c
-  x86/avx512bw.c
-  x86/avx512vl.c
-  x86/avx512dq.c
-  x86/avx512cd.c
   x86/gfni.c
+  x86/clmul.c
   x86/fma.c
   x86/svml.c
-
-  arm/neon/abd.c
-  arm/neon/abs.c
-  arm/neon/add.c
-  arm/neon/addl.c
-  arm/neon/addl_high.c
-  arm/neon/addw.c
-  arm/neon/and.c
-  arm/neon/bsl.c
-  arm/neon/cagt.c
-  arm/neon/ceq.c
-  arm/neon/ceqz.c
-  arm/neon/cge.c
-  arm/neon/cgez.c
-  arm/neon/cgt.c
-  arm/neon/cgtz.c
-  arm/neon/cle.c
-  arm/neon/clez.c
-  arm/neon/clt.c
-  arm/neon/cltz.c
-  arm/neon/cvt.c
-  arm/neon/combine.c
-  arm/neon/create.c
-  arm/neon/dot.c
-  arm/neon/dot_lane.c
-  arm/neon/dup_n.c
-  arm/neon/eor.c
-  arm/neon/ext.c
-  arm/neon/get_high.c
-  arm/neon/get_lane.c
-  arm/neon/get_low.c
-  arm/neon/max.c
-  arm/neon/min.c
-  arm/neon/mla.c
-  arm/neon/mla_n.c
-  arm/neon/mlal.c
-  arm/neon/mlal_high.c
-  arm/neon/movl.c
-  arm/neon/movl_high.c
-  arm/neon/movn.c
-  arm/neon/mul.c
-  arm/neon/mul_n.c
-  arm/neon/mull.c
-  arm/neon/mull_n.c
-  arm/neon/mvn.c
-  arm/neon/neg.c
-  arm/neon/orr.c
-  arm/neon/padal.c
-  arm/neon/padd.c
-  arm/neon/paddl.c
-  arm/neon/pmax.c
-  arm/neon/pmin.c
-  arm/neon/qadd.c
-  arm/neon/qdmulh.c
-  arm/neon/qdmull.c
-  arm/neon/qrdmulh.c
-  arm/neon/qrdmulh_n.c
-  arm/neon/qmovn.c
-  arm/neon/qmovn_high.c
-  arm/neon/qmovun.c
-  arm/neon/qtbl.c
-  arm/neon/qtbx.c
-  arm/neon/rbit.c
-  arm/neon/reinterpret.c
-  arm/neon/rev16.c
-  arm/neon/rev32.c
-  arm/neon/rev64.c
-  arm/neon/rhadd.c
-  arm/neon/rshl.c
-  arm/neon/rshr_n.c
-  arm/neon/rsra_n.c
-  arm/neon/set_lane.c
-  arm/neon/st1_lane.c
-  arm/neon/st3.c
-  arm/neon/st4.c
-  arm/neon/shl.c
-  arm/neon/shl_n.c
-  arm/neon/shr_n.c
-  arm/neon/sra_n.c
-  arm/neon/sub.c
-  arm/neon/subl.c
-  arm/neon/tbl.c
-  arm/neon/tbx.c
-  arm/neon/trn.c
-  arm/neon/trn1.c
-  arm/neon/trn2.c
-  arm/neon/tst.c
-  arm/neon/uzp.c
-  arm/neon/uzp1.c
-  arm/neon/uzp2.c
-  arm/neon/zip.c
-  arm/neon/zip1.c
-  arm/neon/zip2.c
-  )
+  ${X86_AVX512_SOURCES_C}
+  ${ARM_NEON_SOURCES_C})
 
 set(TEST_RUNNER_SOURCES
   run-tests.c
   x86/run-tests.c
+  x86/avx512/run-tests.c
   arm/run-tests.c
   arm/neon/run-tests.c)
 add_executable(run-tests ${TEST_RUNNER_SOURCES})
 set_property(TARGET run-tests PROPERTY C_STANDARD "99")
+target_add_compiler_flags(run-tests "-Wno-psabi")
+
 target_link_libraries(run-tests munit)
 target_add_compiler_flags (munit "-w")
 if(NEED_LIBM)
@@ -237,24 +158,12 @@
 endforeach(native native emul)
 target_compile_definitions(simde-test-emul PRIVATE SIMDE_NO_NATIVE)
 
-foreach(tst
-      "/x86/mmx"
-      "/x86/sse"
-      "/x86/sse2"
-      "/x86/sse3"
-      "/x86/ssse3"
-      "/x86/sse4_1"
-      "/x86/sse4_2"
-      "/x86/avx"
-      "/x86/fma"
-      "/x86/avx2"
-      "/x86/avx512f"
-      "/x86/avx512bw"
-      "/x86/avx512vl"
-      "/x86/avx512dq"
-      "/x86/gfni"
-      "/x86/svml"
-      "/arm"
-    )
-  add_test(NAME "${tst}/${variant}" COMMAND $<TARGET_FILE:run-tests> "${tst}")
-endforeach()
+foreach(src ${TEST_SOURCES_C})
+  string(REGEX REPLACE "^(.+)\\.c$" "/\\1" TEST_NAME "${src}")
+  add_test(NAME "${TEST_NAME}" COMMAND $<TARGET_FILE:run-tests> "${TEST_NAME}")
+endforeach(src ${TEST_SOURCES_C})
+
+message(WARNING
+        "CMake support is deprecated; please use Meson instead.  CMake is only present "
+        "for compilers which Meson doesn't yet support (e.g., xlc) and platforms where "
+        "difficult to run an up-to-date copy of Meson (e.g., Ubuntu 12.04).")

=== debian/changelog ===
simde (0.7.0-1) unstable; urgency=medium

  * debian/watch: only find non-release candidates.
  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * All patches removed except munit, they are no longer needed.
  * Switch to meson/ninja for build+test

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 27 Dec 2020 14:18:39 +0100

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: simde
 Section: libdevel
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Michael R. Crusoe <crusoe@debian.org>
-Build-Depends: clang [!alpha !hppa !ia64 !m68k !sh4 !x32] <!nocheck>,
-               cmake,
-               debhelper-compat (= 12)
-Standards-Version: 4.5.0
+Build-Depends: debhelper-compat (= 13),
+               meson,
+               ninja-build,
+               clang [!alpha !hppa !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !sh4 !x32] <!nocheck>
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/simde
 Vcs-Git: https://salsa.debian.org/med-team/simde.git
 Homepage: https://github.com/simd-everywhere/simde

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
 https://github.com/simd-everywhere/simde/releases/latest .*/archive/v@ANY_VERSION@@ARCHIVE_EXT@

# opts="uversionmangle=s/.*date=(\d{4})-(\d\d)-(\d\d)T.*/0.0.0.git.$1$2$3/, \
#    filenamemangle=s/.*date=(\d{4})-(\d\d)-(\d\d)T.*/0.0.0.git.$1$2$3.tar.gz/, \
#    repack,compression=xz" \
#    https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=github_commits_package_json/nemequ/simde \
#    .*/archive/(.*\.tar\.gz?.*)

## simde 0.7.2

=== meson_options.txt ===
option('tests',
    type : 'boolean',
    value : true,
    description : 'Enable dependencies required for testing')

option('sleef',
    type : 'feature',
    value : 'disabled',
    description : 'Enable SLEEF integration')

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -101,20 +101,12 @@
 list(REMOVE_ITEM X86_AVX512_SOURCES_C "x86/avx512/run-tests.c")
 list(REMOVE_ITEM X86_AVX512_SOURCES_C "x86/avx512/skel.c")
 
+aux_source_directory("x86" X86_SOURCES_C)
+list(REMOVE_ITEM X86_SOURCES_C "x86/skel.c")
+list(REMOVE_ITEM X86_SOURCES_C "x86/run-tests.c")
+
 set(TEST_SOURCES_C
-  x86/mmx.c
-  x86/sse.c
-  x86/sse2.c
-  x86/sse3.c
-  x86/ssse3.c
-  x86/sse4.1.c
-  x86/sse4.2.c
-  x86/avx.c
-  x86/avx2.c
-  x86/gfni.c
-  x86/clmul.c
-  x86/fma.c
-  x86/svml.c
+  ${X86_SOURCES_C}
   ${X86_AVX512_SOURCES_C}
   ${ARM_NEON_SOURCES_C})

=== debian/changelog ===
simde (0.7.2-6) unstable; urgency=medium

  * Team Upload.
  * d/rules: Skip testing on clang for now to get package building

 -- Nilesh Patra <nilesh@debian.org>  Mon, 10 Jan 2022 18:10:36 +0530

simde (0.7.2-5) unstable; urgency=medium

  * Testing: use g{cc,++}-10 until we there is a new release of SIMDe
    with the better GCC 11 support already available upstream.
    Closes: #996281
  * Fix watchfile to detect new versions on github
  * Standards-Version: 4.6.0 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 13 Oct 2021 10:48:30 +0200

simde (0.7.2-4) unstable; urgency=medium

  * debian/control: requires meson >= 0.54. Closes: #983094

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 19 Feb 2021 11:19:59 +0100

simde (0.7.2-3) unstable; urgency=high

  * Autopkgtests: skip known failure of x86/avx512/madd on s390x

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 26 Jan 2021 11:03:28 +0100

simde (0.7.2-2) unstable; urgency=high

  * Autopkgtests: drop clang, simplify deps. Closes: #971429
  * Skip build-time testing with clang on i386 due to known bug.
  * Freshen debian/copyright
  * Remove cruft from debian/watch

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 25 Jan 2021 10:01:52 +0100

simde (0.7.2-1) unstable; urgency=medium

  * New upstream version
  * debian/tests/run-test: make the autopkgtest compilation verbose

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 24 Jan 2021 19:28:30 +0100

simde (0.7.0-2) unstable; urgency=medium

  * Use meson in the autopkgtests, just like during the build, as cmake is
    deprecated for building the tests.

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 31 Dec 2020 20:09:04 +0100

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,11 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               meson,
+               meson (>= 0.54),
                ninja-build,
-               clang [!alpha !hppa !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !sh4 !x32] <!nocheck>
-Standards-Version: 4.5.1
+               gcc-10, g++-10,
+               clang [!i386 !alpha !hppa !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !sh4 !x32] <!nocheck>
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/simde
 Vcs-Git: https://salsa.debian.org/med-team/simde.git
 Homepage: https://github.com/simd-everywhere/simde

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

CLANG_SKIP=i386 alpha hppa ia64 m68k sh4 x32
# i386 is due to https://github.com/simd-everywhere/simde/issues/683
# ppc64 is due to https://github.com/simd-everywhere/simde/issues/185

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

ifneq (,$(filter $(DEB_BUILD_ARCH),armel))
  export DEB_LDFLAGS_MAINT_APPEND=-latomic
endif

%:
	dh $@ --buildsystem=meson+ninja

override_dh_auto_configure:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
	CC=clang CXX=clang++ dh_auto_configure --builddirectory=clang_test
  endif
# According to https://wiki.debian.org/ArchitectureSpecificsMemo#Architecture_baselines
# It is odd that gcc doesn't include this automatically, but clang does
ifneq (,$(filter $(DEB_BUILD_ARCH),ppc64))
  export DEB_CFLAGS_MAINT_APPEND+=-maltivec
  export DEB_CXXFLAGS_MAINT_APPEND+=-maltivec
endif
	CC=gcc-10 CXX=g++-10 dh_auto_configure --builddirectory=gcc_test
endif

override_dh_auto_build:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_build --builddirectory=gcc_test
  ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
	dh_auto_build --builddirectory=clang_test
  endif
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --builddirectory=gcc_test
# Skip testing on clang for now owing to bug report #1002223
#  ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
#	dh_auto_test --builddirectory=clang_test
#  endif
endif

override_dh_auto_clean:
	dh_auto_clean --builddirectory=gcc_test
ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
	dh_auto_clean --builddirectory=clang_test
endif

override_dh_auto_install:
	echo This is a header-only library, no need to install any binaries

=== debian/tests/control ===
Tests: run-unit-test
Depends: libsimde-dev, gcc-10, g++-10, meson, ninja-build, dpkg-dev
Restrictions: allow-stderr

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
 https://github.com/simd-everywhere/simde/releases/latest .*/v@ANY_VERSION@@ARCHIVE_EXT@

## simde 0.7.3~0git20230118123246.d1e75cd

=== debian/changelog ===
simde (0.7.3~0git20230118123246.d1e75cd-2) experimental; urgency=medium

  * d/rules: -O0 for arm64; as -O2 causes one of the complex tests to
    never finish compiling.
  * Only run the non-emul tests, for more speed
  * -O0 for 32-bit x86 due to gcc 12 regression
  * Skip dbsad tests on i686, known failure.
  * armel/armhf tests also needs -O0 due to GCC 12 regression

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 21 Jan 2023 10:11:19 +0100

simde (0.7.3~0git20230118123246.d1e75cd-1) experimental; urgency=medium

  * Test before new release.
  * Drop clang everywhere as we are not testing it.

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 18 Jan 2023 16:33:23 +0100

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
                meson (>= 0.54),
                ninja-build,
-               gcc-10, g++-10,
-               clang [!i386 !alpha !hppa !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !sh4 !x32] <!nocheck>
+#              clang [!i386 !alpha !hppa !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !sh4 !x32] <!nocheck>
 Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/simde
 Vcs-Git: https://salsa.debian.org/med-team/simde.git

=== debian/rules ===
--- 
+++ 
@@ -10,8 +10,29 @@
 include /usr/share/dpkg/default.mk
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 
+# https://github.com/simd-everywhere/simde/issues/982
 ifneq (,$(filter $(DEB_BUILD_ARCH),armel))
   export DEB_LDFLAGS_MAINT_APPEND=-latomic
+  export DEB_CFLAGS_MAINT_APPEND=-O0
+  export DEB_CPPFLAGS_MAINT_APPEND=-O0
+endif
+ifneq (,$(filter $(DEB_BUILD_ARCH),armhf))
+  export DEB_CFLAGS_MAINT_APPEND=-O0
+  export DEB_CPPFLAGS_MAINT_APPEND=-O0
+endif
+
+# on arm64, -O2 (dpkg-buildflag's default) causes test/arm/neon/st4.cpp to not compile
+#  in a reasonable time
+ifneq (,$(filter $(DEB_BUILD_ARCH),arm64))
+  export DEB_CFLAGS_MAINT_APPEND=-O0
+  export DEB_CPPFLAGS_MAINT_APPEND=-O0
+endif
+
+#  https://github.com/simd-everywhere/simde/issues/981
+# -O2 (dpkg-buildflag's default) triggers gcc-12 regressions
+ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
+  export DEB_CFLAGS_MAINT_APPEND=-O0
+  export DEB_CPPFLAGS_MAINT_APPEND=-O0
 endif
 
 %:
@@ -19,29 +40,32 @@
 
 override_dh_auto_configure:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-  ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
-	CC=clang CXX=clang++ dh_auto_configure --builddirectory=clang_test
-  endif
+# Skip testing on clang for now owing to bug report #1002223
+#   ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
+# 	CC=clang CXX=clang++ dh_auto_configure --builddirectory=clang_test
+#   endif
+
+# https://github.com/simd-everywhere/simde/issues/867
+ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
+  sed -i "/'dbsad'/d" meson.build
+  rm test/x86/avx512/dbsad.c
+endif
+
 # According to https://wiki.debian.org/ArchitectureSpecificsMemo#Architecture_baselines
 # It is odd that gcc doesn't include this automatically, but clang does
 ifneq (,$(filter $(DEB_BUILD_ARCH),ppc64))
   export DEB_CFLAGS_MAINT_APPEND+=-maltivec
   export DEB_CXXFLAGS_MAINT_APPEND+=-maltivec
 endif
-	CC=gcc-10 CXX=g++-10 dh_auto_configure --builddirectory=gcc_test
+	CC=gcc CXX=g++ dh_auto_configure --builddirectory=gcc_test
 endif
 
 override_dh_auto_build:
-ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	dh_auto_build --builddirectory=gcc_test
-  ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
-	dh_auto_build --builddirectory=clang_test
-  endif
-endif
+	echo skipping dh_auto_build in favor of dh_auto_test
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	dh_auto_test --builddirectory=gcc_test
+	dh_auto_test --builddirectory=gcc_test -- ${shell meson test -C gcc_test  --list | grep -v emul}
 # Skip testing on clang for now owing to bug report #1002223
 #  ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
 #	dh_auto_test --builddirectory=clang_test

## simde 0.7.4~rc1

=== debian/changelog ===
simde (0.7.4~rc1-1) unstable; urgency=medium

  * watch: switch to Git mode to avoid GitHub release page changes.
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 02 Feb 2023 19:18:54 +0100

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,9 @@
 Build-Depends: debhelper-compat (= 13),
                meson (>= 0.54),
                ninja-build,
-#              clang [!i386 !alpha !hppa !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !sh4 !x32] <!nocheck>
-Standards-Version: 4.6.0
+               gcc-10, g++-10,
+               clang [!i386 !alpha !hppa !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !sh4 !x32] <!nocheck>
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/simde
 Vcs-Git: https://salsa.debian.org/med-team/simde.git
 Homepage: https://github.com/simd-everywhere/simde

## simde 0.7.4~rc2

=== debian/changelog ===
simde (0.7.4~rc2-2) unstable; urgency=medium

  * Autopkgtest s390x: skip arm/neon/qdmulh*

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 14 Feb 2023 18:54:32 +0100

simde (0.7.4~rc2-1) unstable; urgency=medium

  * Build & test with default gcc version.  Closes: #1023687, #1002223
  * New upstream version. Closes: #1030577
  * Skip dbsad tests on i686, known failure. Closes: #102124

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 12 Feb 2023 19:29:01 +0100

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,8 @@
 Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Build-Depends: debhelper-compat (= 13),
                meson (>= 0.54),
-               ninja-build,
-               gcc-10, g++-10,
-               clang [!i386 !alpha !hppa !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !sh4 !x32] <!nocheck>
+               ninja-build
+#              clang [!i386 !alpha !hppa !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !sh4 !x32] <!nocheck>
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/simde
 Vcs-Git: https://salsa.debian.org/med-team/simde.git

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

CLANG_SKIP=i386 alpha hppa ia64 m68k sh4 x32
# i386 is due to https://github.com/simd-everywhere/simde/issues/683
# ppc64 is due to https://github.com/simd-everywhere/simde/issues/185

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

ifneq (,$(filter $(DEB_BUILD_ARCH),armel))
  export DEB_LDFLAGS_MAINT_APPEND=-latomic
endif
ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
  export DEB_CFLAGS_MAINT_APPEND=-O0
  export DEB_CXXFLAGS_MAINT_APPEND=-O0
endif

%:
	dh $@ --buildsystem=meson+ninja

override_dh_auto_configure:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  # ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
	# CC=clang CXX=clang++ dh_auto_configure --builddirectory=clang_test
  # endif
# https://github.com/simd-everywhere/simde/issues/867
ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
	sed -i "/'dbsad'/d" meson.build
	rm test/x86/avx512/dbsad.c
endif
# According to https://wiki.debian.org/ArchitectureSpecificsMemo#Architecture_baselines
# It is odd that gcc doesn't include this automatically, but clang does
ifneq (,$(filter $(DEB_BUILD_ARCH),ppc64))
	export DEB_CFLAGS_MAINT_APPEND+=-maltivec
	export DEB_CXXFLAGS_MAINT_APPEND+=-maltivec
endif
	CC=gcc CXX=g++ dh_auto_configure --builddirectory=gcc_test
endif

override_dh_auto_build:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_build --builddirectory=gcc_test
  # ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
	# dh_auto_build --builddirectory=clang_test
  # endif
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --builddirectory=gcc_test -- ${shell meson test -C gcc_test  --list | grep -v emul}
# Skip testing on clang for now owing to bug report #1002223
#  ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
#	dh_auto_test --builddirectory=clang_test
#  endif
endif

override_dh_auto_clean:
	dh_auto_clean --builddirectory=gcc_test
# ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
# 	dh_auto_clean --builddirectory=clang_test
# endif

override_dh_auto_install:
	echo This is a header-only library, no need to install any binaries

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,mode=git,uversionmangle=s/-rc/~rc/" \
 https://github.com/simd-everywhere/simde.git refs/tags/v?@ANY_VERSION@

## simde 0.7.4

=== debian/changelog ===
simde (0.7.4-0~0exp0) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 05 May 2023 07:56:44 +0200

simde (0.7.4~rc4-0exp) experimental; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 04 May 2023 00:08:20 +0200

## simde 0.7.4+really0.7.4~rc2

=== debian/changelog ===
simde (0.7.4+really0.7.4~rc2-1) unstable; urgency=medium

  * Revert accidental upload of 0.7.4 final to unstable.

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 05 May 2023 13:16:46 +0200
